#include <coff/archive.hpp>
#include <llodctor/llodctor_base.hpp>

namespace llo::s1
{
    class dctor_lib_t : public dctor_base_t
    {
      public:
        explicit dctor_lib_t( const std::vector< std::uint8_t > &image,
                              llo::s1::symbol_loader_base_t *symbol_loader = nullptr )
            : dctor_base_t( image, symbol_loader )
        {
            const auto lib_header = reinterpret_cast< const ar::header_t * >( image.data() );
            auto lib_entry = &lib_header->first_entry;

            do
            {
                // skip these since we dont want to extract them... they are not obj files...
                if ( lib_entry->is_string_table() || lib_entry->is_symbol_table() )
                    continue;

                std::printf( "> object name = %s\n", lib_entry->to_string());
            } while ( ( lib_entry = lib_header->first_entry.next() ) );
        }
        void generate( lloiff_t &iff ) override;
    };
} // namespace llo::s1