#pragma once
#include <cstdint>
#include <lloutils.hpp>

namespace llo
{
    class disposition_t
    {
      public:
        explicit disposition_t( const llo::utils::hash_t< std::string > &iff_name,
                                const llo::utils::hash_t< std::string > &section_name, std::uint32_t section_offset )
            : iff_name( iff_name ), section_name( section_name ), offset( section_offset )
        {
        }

        static std::shared_ptr< disposition_t > make( const llo::utils::hash_t< std::string > &iff_name,
                                                      const llo::utils::hash_t< std::string > &section_name,
                                                      std::uint32_t section_offset );

        llo::utils::hash_t< std::string > iff_name;
        llo::utils::hash_t< std::string > section_name;
        std::uint32_t offset;
    };
} // namespace llo